#include <stdio.h>
#include <stdlib.h>
#include "IOTCClient.h"
#include "IOTCWakeUp.h"
#include "sample_constants.h"

int main(int argc, char *argv[])
{
    if (argc < 2)
    {
        printf("No UID input!!!\n");
        printf("IOTCAPIs_Client <UID>\n");
        return 0;
    }

    char *UID = (char *)argv[1];
    int SID, ret;

    const char *license_key = getenv(ENV_LICENSE_KEY);
    if (license_key == NULL) {
        printf("Environment variable %s must be set!!\n", ENV_LICENSE_KEY);
        return -1;
    }
    ret = TUTK_SDK_Set_License_Key(license_key);
    if (ret != TUTK_ER_NoERROR)
    {
        printf("TUTK_SDK_Set_License_Key()=%d ,exit...!!\n", ret);
        return 0;
    }

    IOTC_Initialize2(0);

    // set IOTC_Connect_ByUID & IOTC_Connect_ByUID_Parallel auto wakeup sleeping device.
    // default value is false. And this setup be reset in IOTC_DeInitialize().
    IOTC_WakeUp_Setup_Auto_WakeUp(1);

    SID = IOTC_Get_SessionID();
    if (SID < 0)
    {
        printf("IOTC_Get_SessionID error [%d]\n", SID);
        return 0;
    }

    ret = IOTC_Connect_ByUID_Parallel(UID, SID);
    printf("call IOTC_Connect_ByUID_Parallel(%s)...[%d]\n", UID, ret);
    if (ret == IOTC_ER_DEVICE_REJECT_BYPORT)
    {
        printf("Device is not yet call IOTC_Listen(), please retry\n");
    }

    IOTC_Session_Close(SID);
    IOTC_DeInitialize();
    return 0;
}
